Explorer(2019年牛客多校第八场E题+线段树+可撤销并查集)

题目链接

传送门

题意

给你一张无向图,每条边(u_i,v_i)的权值范围为([L_i,R_i]),要经过这条边的条件是你的容量要在([L_i,R_i]),现在问你你有多少种容量使得你可以从(1)走到(n)

思路

跟着大佬们的代码学了波可撤销并查集和线段树骚操作,感觉自己好菜啊。

首先我们用并查集来维护哪些边的权值范围在线段树结点对应的区间内,用(vector)来存下结点编号(注意由于区间范围太大我们需要离散化建左闭右开线段树)。在查询的时候一路向下,将经过的结点存的所有边的编号对应的两个端点用并查集维护连通性,当到达线段树叶子结点时就说明所有包含这个叶子结点对应的区间的边都用并查集维护了,此时再判断(1)(n)是否在一个连通块里面,在就将这个区间的长度加到答案里面,不在就说明这个结点对应的区间无法使得从(1)走到(n),在回溯的时候撤销之前并查集的合并集合操作。

代码

#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <cmath>
#include <ctime>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef pair<LL, LL> pLL;
typedef pair<LL, int> pLi;
typedef pair<int, LL> pil;;
typedef pair<int, int> pii;
typedef unsigned long long uLL;

#define lson (rt<<1),L,mid
#define rson (rt<<1|1),mid + 1,R
#define lowbit(x) x&(-x)
#define name2str(name) (#name)
#define bug printf("*********
")
#define debug(x) cout<<#x"=["<<x<<"]" <<endl
#define FIN freopen("/home/dillonh/CLionProjects/Dillonh/in.txt","r",stdin)
#define IO ios::sync_with_stdio(false),cin.tie(0)

const double eps = 1e-8;
const int mod = 1000000007;
const int maxn = 200000 + 7;
const double pi = acos(-1);
const int inf = 0x3f3f3f3f;
const LL INF = 0x3f3f3f3f3f3f3f3fLL;

pii st[maxn*4];
int n, m, tot, tp, ans;
vector<int> vec[maxn*4];
int u[maxn], v[maxn], L[maxn], R[maxn];
int num[maxn*2], fa[maxn], sz[maxn];

int fi(int x) {
    return fa[x] == x ? x : fi(fa[x]);
}

void merge(int u, int v) {
    int x = fi(u), y = fi(v);
    if(x == y) {
        st[++tp] = {-1, -1};  //按照我的写法不能省略,因为我是根据结点对应的vector的size来撤消的,少了这个那么tp会减到负数导致re。
        return;
    }
    if(sz[x] < sz[y]) swap(x, y);
    sz[x] += sz[y];
    fa[y] = x;
    st[++tp] = {x, y};
}

void cancel() {
    int x = st[tp].first;
    int y = st[tp--].second;
    if(x == -1) return;
    sz[x] -= sz[y];
    fa[y] = y;
}

void update(int l, int r, int id, int rt, int L, int R) {
    if(l <= L && R <= r) {
        vec[rt].emplace_back(id);
        return;
    }
    int mid = (L + R) >> 1;
    if(r <= mid) update(l, r, id, lson);
    else if(l > mid) update(l, r, id, rson);
    else {
        update(l, mid, id, lson);
        update(mid + 1, r, id, rson);
    }
}

void query(int l, int r, int rt) {
    for(int i = 0; i < (int)vec[rt].size(); ++i) {
        int id = vec[rt][i];
        merge(u[id], v[id]);
    }
    if(l == r) {
        int x = fi(1), y = fi(n);
        if(x == y) {
            ans += num[r+1] - num[l];
        }
        for(int i = 0; i < (int)vec[rt].size(); ++i) {
            cancel();
        }
        return;
    }
    int mid = (l + r) >> 1;
    query(l, mid, rt<<1);
    query(mid + 1, r, rt<<1|1);
    for(int i = 0; i < (int)vec[rt].size(); ++i) {
        cancel();
    }
}

int main() {
#ifndef ONLINE_JUDGE
    FIN;
#endif
    scanf("%d%d", &n, &m);
    for(int i = 1; i <= m; ++i) {
        scanf("%d%d%d%d", &u[i], &v[i], &L[i], &R[i]);
        num[++tot] = L[i];
        num[++tot] = R[i] + 1;
    }
    sort(num + 1, num + tot + 1);
    tot = unique(num + 1, num + tot + 1) - num - 1;
    for(int i = 1; i <= m; ++i) {
        int l = lower_bound(num + 1, num + tot + 1, L[i]) - num;
        int r = lower_bound(num + 1, num + tot + 1, R[i] + 1) - num;
        update(l, r - 1, i, 1, 1, tot);
    }
    for(int i = 1; i <= n; ++i) fa[i] = i, sz[i] = 1;
    query(1, tot, 1);
    printf("%d
", ans);
    return 0;
}
原文地址:https://www.cnblogs.com/Dillonh/p/11334020.html